# Copyright (c) 2012-2021, Mark Peek <mark@peek.org>
# All rights reserved.
#
# See LICENSE file for full license.

from typing import Optional

from .aws import Action as BaseAction
from .aws import BaseARN

service_name = "Amazon DataZone"
prefix = "datazone"


class Action(BaseAction):
    def __init__(self, action: Optional[str] = None) -> None:
        super().__init__(prefix, action)


class ARN(BaseARN):
    def __init__(self, resource: str = "", region: str = "", account: str = "") -> None:
        super().__init__(
            service=prefix, resource=resource, region=region, account=account
        )


AcceptPredictions = Action("AcceptPredictions")
AcceptSubscriptionRequest = Action("AcceptSubscriptionRequest")
AddEntityOwner = Action("AddEntityOwner")
AddPolicyGrant = Action("AddPolicyGrant")
AssociateEnvironmentRole = Action("AssociateEnvironmentRole")
BatchDeleteLinkedTypes = Action("BatchDeleteLinkedTypes")
BatchPutLinkedTypes = Action("BatchPutLinkedTypes")
CancelMetadataGenerationRun = Action("CancelMetadataGenerationRun")
CancelSubscription = Action("CancelSubscription")
CreateAsset = Action("CreateAsset")
CreateAssetFilter = Action("CreateAssetFilter")
CreateAssetRevision = Action("CreateAssetRevision")
CreateAssetType = Action("CreateAssetType")
CreateConnection = Action("CreateConnection")
CreateDataProduct = Action("CreateDataProduct")
CreateDataProductRevision = Action("CreateDataProductRevision")
CreateDataSource = Action("CreateDataSource")
CreateDomain = Action("CreateDomain")
CreateDomainUnit = Action("CreateDomainUnit")
CreateEnvironment = Action("CreateEnvironment")
CreateEnvironmentAction = Action("CreateEnvironmentAction")
CreateEnvironmentBlueprint = Action("CreateEnvironmentBlueprint")
CreateEnvironmentProfile = Action("CreateEnvironmentProfile")
CreateFormType = Action("CreateFormType")
CreateGlossary = Action("CreateGlossary")
CreateGlossaryTerm = Action("CreateGlossaryTerm")
CreateGroupProfile = Action("CreateGroupProfile")
CreateListingChangeSet = Action("CreateListingChangeSet")
CreateProject = Action("CreateProject")
CreateProjectMembership = Action("CreateProjectMembership")
CreateProjectProfile = Action("CreateProjectProfile")
CreateRule = Action("CreateRule")
CreateSubscriptionGrant = Action("CreateSubscriptionGrant")
CreateSubscriptionRequest = Action("CreateSubscriptionRequest")
CreateSubscriptionTarget = Action("CreateSubscriptionTarget")
CreateUserProfile = Action("CreateUserProfile")
DeleteAsset = Action("DeleteAsset")
DeleteAssetFilter = Action("DeleteAssetFilter")
DeleteAssetType = Action("DeleteAssetType")
DeleteConnection = Action("DeleteConnection")
DeleteDataProduct = Action("DeleteDataProduct")
DeleteDataSource = Action("DeleteDataSource")
DeleteDomain = Action("DeleteDomain")
DeleteDomainSharingPolicy = Action("DeleteDomainSharingPolicy")
DeleteDomainUnit = Action("DeleteDomainUnit")
DeleteEnvironment = Action("DeleteEnvironment")
DeleteEnvironmentAction = Action("DeleteEnvironmentAction")
DeleteEnvironmentBlueprint = Action("DeleteEnvironmentBlueprint")
DeleteEnvironmentBlueprintConfiguration = Action(
    "DeleteEnvironmentBlueprintConfiguration"
)
DeleteEnvironmentProfile = Action("DeleteEnvironmentProfile")
DeleteFormType = Action("DeleteFormType")
DeleteGlossary = Action("DeleteGlossary")
DeleteGlossaryTerm = Action("DeleteGlossaryTerm")
DeleteListing = Action("DeleteListing")
DeleteProject = Action("DeleteProject")
DeleteProjectMembership = Action("DeleteProjectMembership")
DeleteProjectProfile = Action("DeleteProjectProfile")
DeleteRule = Action("DeleteRule")
DeleteSubscriptionGrant = Action("DeleteSubscriptionGrant")
DeleteSubscriptionRequest = Action("DeleteSubscriptionRequest")
DeleteSubscriptionTarget = Action("DeleteSubscriptionTarget")
DeleteTimeSeriesDataPoints = Action("DeleteTimeSeriesDataPoints")
DisassociateEnvironmentRole = Action("DisassociateEnvironmentRole")
GetAsset = Action("GetAsset")
GetAssetFilter = Action("GetAssetFilter")
GetAssetType = Action("GetAssetType")
GetConnection = Action("GetConnection")
GetDataProduct = Action("GetDataProduct")
GetDataSource = Action("GetDataSource")
GetDataSourceRun = Action("GetDataSourceRun")
GetDomain = Action("GetDomain")
GetDomainExecutionRoleCredentials = Action("GetDomainExecutionRoleCredentials")
GetDomainSharingPolicy = Action("GetDomainSharingPolicy")
GetDomainUnit = Action("GetDomainUnit")
GetEnvironment = Action("GetEnvironment")
GetEnvironmentAction = Action("GetEnvironmentAction")
GetEnvironmentActionLink = Action("GetEnvironmentActionLink")
GetEnvironmentBlueprint = Action("GetEnvironmentBlueprint")
GetEnvironmentBlueprintConfiguration = Action("GetEnvironmentBlueprintConfiguration")
GetEnvironmentCredentials = Action("GetEnvironmentCredentials")
GetEnvironmentProfile = Action("GetEnvironmentProfile")
GetFormType = Action("GetFormType")
GetGlossary = Action("GetGlossary")
GetGlossaryTerm = Action("GetGlossaryTerm")
GetGroupProfile = Action("GetGroupProfile")
GetIamPortalLoginUrl = Action("GetIamPortalLoginUrl")
GetJobRun = Action("GetJobRun")
GetLineageEvent = Action("GetLineageEvent")
GetLineageNode = Action("GetLineageNode")
GetListing = Action("GetListing")
GetMetadataGenerationRun = Action("GetMetadataGenerationRun")
GetProject = Action("GetProject")
GetProjectConfiguration = Action("GetProjectConfiguration")
GetProjectCredentials = Action("GetProjectCredentials")
GetProjectProfile = Action("GetProjectProfile")
GetRule = Action("GetRule")
GetSubscription = Action("GetSubscription")
GetSubscriptionEligibility = Action("GetSubscriptionEligibility")
GetSubscriptionGrant = Action("GetSubscriptionGrant")
GetSubscriptionRequestDetails = Action("GetSubscriptionRequestDetails")
GetSubscriptionTarget = Action("GetSubscriptionTarget")
GetTimeSeriesDataPoint = Action("GetTimeSeriesDataPoint")
GetUserProfile = Action("GetUserProfile")
ListAccountEnvironments = Action("ListAccountEnvironments")
ListAssetFilters = Action("ListAssetFilters")
ListAssetRevisions = Action("ListAssetRevisions")
ListConnections = Action("ListConnections")
ListDataProductRevisions = Action("ListDataProductRevisions")
ListDataSourceRunActivities = Action("ListDataSourceRunActivities")
ListDataSourceRuns = Action("ListDataSourceRuns")
ListDataSources = Action("ListDataSources")
ListDomainUnitsForParent = Action("ListDomainUnitsForParent")
ListDomains = Action("ListDomains")
ListEntityOwners = Action("ListEntityOwners")
ListEnvironmentActions = Action("ListEnvironmentActions")
ListEnvironmentBlueprintConfigurationSummaries = Action(
    "ListEnvironmentBlueprintConfigurationSummaries"
)
ListEnvironmentBlueprintConfigurations = Action(
    "ListEnvironmentBlueprintConfigurations"
)
ListEnvironmentBlueprints = Action("ListEnvironmentBlueprints")
ListEnvironmentProfiles = Action("ListEnvironmentProfiles")
ListEnvironments = Action("ListEnvironments")
ListGroupsForUser = Action("ListGroupsForUser")
ListJobRuns = Action("ListJobRuns")
ListLineageEvents = Action("ListLineageEvents")
ListLineageNodeHistory = Action("ListLineageNodeHistory")
ListLinkedTypes = Action("ListLinkedTypes")
ListMetadataGenerationRuns = Action("ListMetadataGenerationRuns")
ListNotifications = Action("ListNotifications")
ListPolicyGrants = Action("ListPolicyGrants")
ListProjectMemberships = Action("ListProjectMemberships")
ListProjectProfiles = Action("ListProjectProfiles")
ListProjects = Action("ListProjects")
ListRules = Action("ListRules")
ListSubscriptionGrants = Action("ListSubscriptionGrants")
ListSubscriptionRequests = Action("ListSubscriptionRequests")
ListSubscriptionTargets = Action("ListSubscriptionTargets")
ListSubscriptions = Action("ListSubscriptions")
ListTagsForResource = Action("ListTagsForResource")
ListTimeSeriesDataPoints = Action("ListTimeSeriesDataPoints")
ListUserProjects = Action("ListUserProjects")
ListWarehouseMetadata = Action("ListWarehouseMetadata")
PostLineageEvent = Action("PostLineageEvent")
PostTimeSeriesDataPoints = Action("PostTimeSeriesDataPoints")
ProvisionDomain = Action("ProvisionDomain")
PutDomainSharingPolicy = Action("PutDomainSharingPolicy")
PutEnvironmentBlueprintConfiguration = Action("PutEnvironmentBlueprintConfiguration")
RefreshToken = Action("RefreshToken")
RejectPredictions = Action("RejectPredictions")
RejectSubscriptionRequest = Action("RejectSubscriptionRequest")
RemoveEntityOwner = Action("RemoveEntityOwner")
RemovePolicyGrant = Action("RemovePolicyGrant")
RevokeSubscription = Action("RevokeSubscription")
Search = Action("Search")
SearchGroupProfiles = Action("SearchGroupProfiles")
SearchListings = Action("SearchListings")
SearchRules = Action("SearchRules")
SearchTypes = Action("SearchTypes")
SearchUserProfiles = Action("SearchUserProfiles")
SsoLogin = Action("SsoLogin")
SsoLogout = Action("SsoLogout")
StartDataSourceRun = Action("StartDataSourceRun")
StartMetadataGenerationRun = Action("StartMetadataGenerationRun")
StopMetadataGenerationRun = Action("StopMetadataGenerationRun")
TagResource = Action("TagResource")
UntagResource = Action("UntagResource")
UpdateAssetFilter = Action("UpdateAssetFilter")
UpdateConnection = Action("UpdateConnection")
UpdateDataSource = Action("UpdateDataSource")
UpdateDataSourceRunActivities = Action("UpdateDataSourceRunActivities")
UpdateDomain = Action("UpdateDomain")
UpdateDomainUnit = Action("UpdateDomainUnit")
UpdateEnvironment = Action("UpdateEnvironment")
UpdateEnvironmentAction = Action("UpdateEnvironmentAction")
UpdateEnvironmentBlueprint = Action("UpdateEnvironmentBlueprint")
UpdateEnvironmentConfiguration = Action("UpdateEnvironmentConfiguration")
UpdateEnvironmentDeploymentStatus = Action("UpdateEnvironmentDeploymentStatus")
UpdateEnvironmentProfile = Action("UpdateEnvironmentProfile")
UpdateGlossary = Action("UpdateGlossary")
UpdateGlossaryTerm = Action("UpdateGlossaryTerm")
UpdateGroupProfile = Action("UpdateGroupProfile")
UpdateProject = Action("UpdateProject")
UpdateProjectProfile = Action("UpdateProjectProfile")
UpdateRule = Action("UpdateRule")
UpdateSubscriptionGrantStatus = Action("UpdateSubscriptionGrantStatus")
UpdateSubscriptionRequest = Action("UpdateSubscriptionRequest")
UpdateSubscriptionTarget = Action("UpdateSubscriptionTarget")
UpdateUserProfile = Action("UpdateUserProfile")
ValidatePassRole = Action("ValidatePassRole")
