# Copyright (c) 2012-2021, Mark Peek <mark@peek.org>
# All rights reserved.
#
# See LICENSE file for full license.

from typing import Optional

from .aws import Action as BaseAction
from .aws import BaseARN

service_name = "AWS Glue"
prefix = "glue"


class Action(BaseAction):
    def __init__(self, action: Optional[str] = None) -> None:
        super().__init__(prefix, action)


class ARN(BaseARN):
    def __init__(self, resource: str = "", region: str = "", account: str = "") -> None:
        super().__init__(
            service=prefix, resource=resource, region=region, account=account
        )


AuthorizeInboundIntegration = Action("AuthorizeInboundIntegration")
BatchCreatePartition = Action("BatchCreatePartition")
BatchDeleteConnection = Action("BatchDeleteConnection")
BatchDeletePartition = Action("BatchDeletePartition")
BatchDeleteTable = Action("BatchDeleteTable")
BatchDeleteTableVersion = Action("BatchDeleteTableVersion")
BatchGetBlueprints = Action("BatchGetBlueprints")
BatchGetCrawlers = Action("BatchGetCrawlers")
BatchGetCustomEntityTypes = Action("BatchGetCustomEntityTypes")
BatchGetDevEndpoints = Action("BatchGetDevEndpoints")
BatchGetJobs = Action("BatchGetJobs")
BatchGetPartition = Action("BatchGetPartition")
BatchGetStageFiles = Action("BatchGetStageFiles")
BatchGetTableOptimizer = Action("BatchGetTableOptimizer")
BatchGetTriggers = Action("BatchGetTriggers")
BatchGetWorkflows = Action("BatchGetWorkflows")
BatchStopJobRun = Action("BatchStopJobRun")
BatchUpdatePartition = Action("BatchUpdatePartition")
CancelDataQualityRuleRecommendationRun = Action(
    "CancelDataQualityRuleRecommendationRun"
)
CancelDataQualityRulesetEvaluationRun = Action("CancelDataQualityRulesetEvaluationRun")
CancelMLTaskRun = Action("CancelMLTaskRun")
CancelStatement = Action("CancelStatement")
CheckSchemaVersionValidity = Action("CheckSchemaVersionValidity")
CreateBlueprint = Action("CreateBlueprint")
CreateCatalog = Action("CreateCatalog")
CreateClassifier = Action("CreateClassifier")
CreateColumnStatisticsTaskSettings = Action("CreateColumnStatisticsTaskSettings")
CreateConnection = Action("CreateConnection")
CreateCrawler = Action("CreateCrawler")
CreateCustomEntityType = Action("CreateCustomEntityType")
CreateDataQualityRuleset = Action("CreateDataQualityRuleset")
CreateDatabase = Action("CreateDatabase")
CreateDevEndpoint = Action("CreateDevEndpoint")
CreateInboundIntegration = Action("CreateInboundIntegration")
CreateIntegration = Action("CreateIntegration")
CreateIntegrationResourceProperty = Action("CreateIntegrationResourceProperty")
CreateIntegrationTableProperties = Action("CreateIntegrationTableProperties")
CreateJob = Action("CreateJob")
CreateMLTransform = Action("CreateMLTransform")
CreatePartition = Action("CreatePartition")
CreatePartitionIndex = Action("CreatePartitionIndex")
CreateRegistry = Action("CreateRegistry")
CreateSchema = Action("CreateSchema")
CreateScript = Action("CreateScript")
CreateSecurityConfiguration = Action("CreateSecurityConfiguration")
CreateSession = Action("CreateSession")
CreateTable = Action("CreateTable")
CreateTableOptimizer = Action("CreateTableOptimizer")
CreateTrigger = Action("CreateTrigger")
CreateUsageProfile = Action("CreateUsageProfile")
CreateUserDefinedFunction = Action("CreateUserDefinedFunction")
CreateWorkflow = Action("CreateWorkflow")
DeleteBlueprint = Action("DeleteBlueprint")
DeleteCatalog = Action("DeleteCatalog")
DeleteClassifier = Action("DeleteClassifier")
DeleteColumnStatisticsForPartition = Action("DeleteColumnStatisticsForPartition")
DeleteColumnStatisticsForTable = Action("DeleteColumnStatisticsForTable")
DeleteColumnStatisticsTaskSettings = Action("DeleteColumnStatisticsTaskSettings")
DeleteConnection = Action("DeleteConnection")
DeleteCrawler = Action("DeleteCrawler")
DeleteCustomEntityType = Action("DeleteCustomEntityType")
DeleteDataQualityRuleset = Action("DeleteDataQualityRuleset")
DeleteDatabase = Action("DeleteDatabase")
DeleteDevEndpoint = Action("DeleteDevEndpoint")
DeleteIntegration = Action("DeleteIntegration")
DeleteIntegrationTableProperties = Action("DeleteIntegrationTableProperties")
DeleteJob = Action("DeleteJob")
DeleteMLTransform = Action("DeleteMLTransform")
DeletePartition = Action("DeletePartition")
DeletePartitionIndex = Action("DeletePartitionIndex")
DeleteRegistry = Action("DeleteRegistry")
DeleteResourcePolicy = Action("DeleteResourcePolicy")
DeleteSchema = Action("DeleteSchema")
DeleteSchemaVersions = Action("DeleteSchemaVersions")
DeleteSecurityConfiguration = Action("DeleteSecurityConfiguration")
DeleteSession = Action("DeleteSession")
DeleteTable = Action("DeleteTable")
DeleteTableOptimizer = Action("DeleteTableOptimizer")
DeleteTableVersion = Action("DeleteTableVersion")
DeleteTrigger = Action("DeleteTrigger")
DeleteUsageProfile = Action("DeleteUsageProfile")
DeleteUserDefinedFunction = Action("DeleteUserDefinedFunction")
DeleteWorkflow = Action("DeleteWorkflow")
DeregisterDataPreview = Action("DeregisterDataPreview")
DescribeConnectionType = Action("DescribeConnectionType")
DescribeEntity = Action("DescribeEntity")
DescribeInboundIntegrations = Action("DescribeInboundIntegrations")
DescribeIntegrations = Action("DescribeIntegrations")
GetBlueprint = Action("GetBlueprint")
GetBlueprintRun = Action("GetBlueprintRun")
GetBlueprintRuns = Action("GetBlueprintRuns")
GetCatalog = Action("GetCatalog")
GetCatalogImportStatus = Action("GetCatalogImportStatus")
GetCatalogs = Action("GetCatalogs")
GetClassifier = Action("GetClassifier")
GetClassifiers = Action("GetClassifiers")
GetColumnStatisticsForPartition = Action("GetColumnStatisticsForPartition")
GetColumnStatisticsForTable = Action("GetColumnStatisticsForTable")
GetColumnStatisticsTaskRun = Action("GetColumnStatisticsTaskRun")
GetColumnStatisticsTaskRuns = Action("GetColumnStatisticsTaskRuns")
GetColumnStatisticsTaskSettings = Action("GetColumnStatisticsTaskSettings")
GetCompletion = Action("GetCompletion")
GetConnection = Action("GetConnection")
GetConnections = Action("GetConnections")
GetCrawler = Action("GetCrawler")
GetCrawlerMetrics = Action("GetCrawlerMetrics")
GetCrawlers = Action("GetCrawlers")
GetCustomEntityType = Action("GetCustomEntityType")
GetDashboardUrl = Action("GetDashboardUrl")
GetDataCatalogEncryptionSettings = Action("GetDataCatalogEncryptionSettings")
GetDataPreviewStatement = Action("GetDataPreviewStatement")
GetDataQualityModel = Action("GetDataQualityModel")
GetDataQualityModelResult = Action("GetDataQualityModelResult")
GetDataQualityResult = Action("GetDataQualityResult")
GetDataQualityRuleRecommendationRun = Action("GetDataQualityRuleRecommendationRun")
GetDataQualityRuleset = Action("GetDataQualityRuleset")
GetDataQualityRulesetEvaluationRun = Action("GetDataQualityRulesetEvaluationRun")
GetDatabase = Action("GetDatabase")
GetDatabases = Action("GetDatabases")
GetDataflowGraph = Action("GetDataflowGraph")
GetDevEndpoint = Action("GetDevEndpoint")
GetDevEndpoints = Action("GetDevEndpoints")
GetEntityRecords = Action("GetEntityRecords")
GetEnvironment = Action("GetEnvironment")
GetExecutors = Action("GetExecutors")
GetExecutorsThreads = Action("GetExecutorsThreads")
GetGeneratedCode = Action("GetGeneratedCode")
GetIntegrationResourceProperty = Action("GetIntegrationResourceProperty")
GetIntegrationTableProperties = Action("GetIntegrationTableProperties")
GetJob = Action("GetJob")
GetJobBookmark = Action("GetJobBookmark")
GetJobRun = Action("GetJobRun")
GetJobRuns = Action("GetJobRuns")
GetJobUpgradeAnalysis = Action("GetJobUpgradeAnalysis")
GetJobs = Action("GetJobs")
GetLogParsingStatus = Action("GetLogParsingStatus")
GetMLTaskRun = Action("GetMLTaskRun")
GetMLTaskRuns = Action("GetMLTaskRuns")
GetMLTransform = Action("GetMLTransform")
GetMLTransforms = Action("GetMLTransforms")
GetMapping = Action("GetMapping")
GetNotebookInstanceStatus = Action("GetNotebookInstanceStatus")
GetPartition = Action("GetPartition")
GetPartitionIndexes = Action("GetPartitionIndexes")
GetPartitions = Action("GetPartitions")
GetPlan = Action("GetPlan")
GetQueries = Action("GetQueries")
GetQuery = Action("GetQuery")
GetRecipeAction = Action("GetRecipeAction")
GetRegistry = Action("GetRegistry")
GetResourcePolicies = Action("GetResourcePolicies")
GetResourcePolicy = Action("GetResourcePolicy")
GetSchema = Action("GetSchema")
GetSchemaByDefinition = Action("GetSchemaByDefinition")
GetSchemaVersion = Action("GetSchemaVersion")
GetSchemaVersionsDiff = Action("GetSchemaVersionsDiff")
GetSecurityConfiguration = Action("GetSecurityConfiguration")
GetSecurityConfigurations = Action("GetSecurityConfigurations")
GetSession = Action("GetSession")
GetStage = Action("GetStage")
GetStageAttempt = Action("GetStageAttempt")
GetStageAttemptTaskList = Action("GetStageAttemptTaskList")
GetStageAttemptTaskSummary = Action("GetStageAttemptTaskSummary")
GetStageFiles = Action("GetStageFiles")
GetStages = Action("GetStages")
GetStatement = Action("GetStatement")
GetStorage = Action("GetStorage")
GetStorageUnit = Action("GetStorageUnit")
GetTable = Action("GetTable")
GetTableOptimizer = Action("GetTableOptimizer")
GetTableVersion = Action("GetTableVersion")
GetTableVersions = Action("GetTableVersions")
GetTables = Action("GetTables")
GetTags = Action("GetTags")
GetTrigger = Action("GetTrigger")
GetTriggers = Action("GetTriggers")
GetUsageProfile = Action("GetUsageProfile")
GetUserDefinedFunction = Action("GetUserDefinedFunction")
GetUserDefinedFunctions = Action("GetUserDefinedFunctions")
GetWorkflow = Action("GetWorkflow")
GetWorkflowRun = Action("GetWorkflowRun")
GetWorkflowRunProperties = Action("GetWorkflowRunProperties")
GetWorkflowRuns = Action("GetWorkflowRuns")
GlueNotebookAuthorize = Action("GlueNotebookAuthorize")
GlueNotebookRefreshCredentials = Action("GlueNotebookRefreshCredentials")
ImportCatalogToGlue = Action("ImportCatalogToGlue")
ListBlueprints = Action("ListBlueprints")
ListColumnStatisticsTaskRuns = Action("ListColumnStatisticsTaskRuns")
ListConnectionTypes = Action("ListConnectionTypes")
ListCrawlers = Action("ListCrawlers")
ListCrawls = Action("ListCrawls")
ListCustomEntityTypes = Action("ListCustomEntityTypes")
ListDataQualityResults = Action("ListDataQualityResults")
ListDataQualityRuleRecommendationRuns = Action("ListDataQualityRuleRecommendationRuns")
ListDataQualityRulesetEvaluationRuns = Action("ListDataQualityRulesetEvaluationRuns")
ListDataQualityRulesets = Action("ListDataQualityRulesets")
ListDevEndpoints = Action("ListDevEndpoints")
ListEntities = Action("ListEntities")
ListJobUpgradeAnalyses = Action("ListJobUpgradeAnalyses")
ListJobs = Action("ListJobs")
ListMLTransforms = Action("ListMLTransforms")
ListRegistries = Action("ListRegistries")
ListSchemaVersions = Action("ListSchemaVersions")
ListSchemas = Action("ListSchemas")
ListSessions = Action("ListSessions")
ListStatements = Action("ListStatements")
ListTableOptimizerRuns = Action("ListTableOptimizerRuns")
ListTriggers = Action("ListTriggers")
ListUsageProfiles = Action("ListUsageProfiles")
ListWorkflows = Action("ListWorkflows")
ModifyIntegration = Action("ModifyIntegration")
NotifyEvent = Action("NotifyEvent")
PassConnection = Action("PassConnection")
PublishDataQuality = Action("PublishDataQuality")
PutDataCatalogEncryptionSettings = Action("PutDataCatalogEncryptionSettings")
PutDataQualityProfileAnnotation = Action("PutDataQualityProfileAnnotation")
PutDataQualityStatisticAnnotation = Action("PutDataQualityStatisticAnnotation")
PutResourcePolicy = Action("PutResourcePolicy")
PutSchemaVersionMetadata = Action("PutSchemaVersionMetadata")
PutWorkflowRunProperties = Action("PutWorkflowRunProperties")
QuerySchemaVersionMetadata = Action("QuerySchemaVersionMetadata")
RefreshOAuth2Tokens = Action("RefreshOAuth2Tokens")
RegisterSchemaVersion = Action("RegisterSchemaVersion")
RemoveSchemaVersionMetadata = Action("RemoveSchemaVersionMetadata")
RequestLogParsing = Action("RequestLogParsing")
ResetJobBookmark = Action("ResetJobBookmark")
ResumeWorkflowRun = Action("ResumeWorkflowRun")
RunDataPreviewStatement = Action("RunDataPreviewStatement")
RunStatement = Action("RunStatement")
SearchTables = Action("SearchTables")
SendFeedback = Action("SendFeedback")
SendRecipeAction = Action("SendRecipeAction")
StartBlueprintRun = Action("StartBlueprintRun")
StartColumnStatisticsTaskRun = Action("StartColumnStatisticsTaskRun")
StartColumnStatisticsTaskRunSchedule = Action("StartColumnStatisticsTaskRunSchedule")
StartCompletion = Action("StartCompletion")
StartCrawler = Action("StartCrawler")
StartCrawlerSchedule = Action("StartCrawlerSchedule")
StartDataQualityRuleRecommendationRun = Action("StartDataQualityRuleRecommendationRun")
StartDataQualityRulesetEvaluationRun = Action("StartDataQualityRulesetEvaluationRun")
StartExportLabelsTaskRun = Action("StartExportLabelsTaskRun")
StartImportLabelsTaskRun = Action("StartImportLabelsTaskRun")
StartJobRun = Action("StartJobRun")
StartJobUpgradeAnalysis = Action("StartJobUpgradeAnalysis")
StartMLEvaluationTaskRun = Action("StartMLEvaluationTaskRun")
StartMLLabelingSetGenerationTaskRun = Action("StartMLLabelingSetGenerationTaskRun")
StartNotebook = Action("StartNotebook")
StartTrigger = Action("StartTrigger")
StartWorkflowRun = Action("StartWorkflowRun")
StopColumnStatisticsTaskRun = Action("StopColumnStatisticsTaskRun")
StopColumnStatisticsTaskRunSchedule = Action("StopColumnStatisticsTaskRunSchedule")
StopCrawler = Action("StopCrawler")
StopCrawlerSchedule = Action("StopCrawlerSchedule")
StopJobUpgradeAnalysis = Action("StopJobUpgradeAnalysis")
StopSession = Action("StopSession")
StopTrigger = Action("StopTrigger")
StopWorkflowRun = Action("StopWorkflowRun")
TagResource = Action("TagResource")
TerminateNotebook = Action("TerminateNotebook")
TestConnection = Action("TestConnection")
UntagResource = Action("UntagResource")
UpdateBlueprint = Action("UpdateBlueprint")
UpdateCatalog = Action("UpdateCatalog")
UpdateClassifier = Action("UpdateClassifier")
UpdateColumnStatisticsForPartition = Action("UpdateColumnStatisticsForPartition")
UpdateColumnStatisticsForTable = Action("UpdateColumnStatisticsForTable")
UpdateColumnStatisticsTaskSettings = Action("UpdateColumnStatisticsTaskSettings")
UpdateConnection = Action("UpdateConnection")
UpdateCrawler = Action("UpdateCrawler")
UpdateCrawlerSchedule = Action("UpdateCrawlerSchedule")
UpdateDataQualityRuleset = Action("UpdateDataQualityRuleset")
UpdateDatabase = Action("UpdateDatabase")
UpdateDevEndpoint = Action("UpdateDevEndpoint")
UpdateIntegrationResourceProperty = Action("UpdateIntegrationResourceProperty")
UpdateIntegrationTableProperties = Action("UpdateIntegrationTableProperties")
UpdateJob = Action("UpdateJob")
UpdateJobFromSourceControl = Action("UpdateJobFromSourceControl")
UpdateMLTransform = Action("UpdateMLTransform")
UpdatePartition = Action("UpdatePartition")
UpdateRegistry = Action("UpdateRegistry")
UpdateSchema = Action("UpdateSchema")
UpdateSourceControlFromJob = Action("UpdateSourceControlFromJob")
UpdateTable = Action("UpdateTable")
UpdateTableOptimizer = Action("UpdateTableOptimizer")
UpdateTrigger = Action("UpdateTrigger")
UpdateUsageProfile = Action("UpdateUsageProfile")
UpdateUserDefinedFunction = Action("UpdateUserDefinedFunction")
UpdateWorkflow = Action("UpdateWorkflow")
UpgradeJob = Action("UpgradeJob")
UseGlueStudio = Action("UseGlueStudio")
UseMLTransforms = Action("UseMLTransforms")
