# Copyright (c) 2012-2021, Mark Peek <mark@peek.org>
# All rights reserved.
#
# See LICENSE file for full license.

from typing import Optional

from .aws import Action as BaseAction
from .aws import BaseARN

service_name = "AWS Elemental MediaLive"
prefix = "medialive"


class Action(BaseAction):
    def __init__(self, action: Optional[str] = None) -> None:
        super().__init__(prefix, action)


class ARN(BaseARN):
    def __init__(self, resource: str = "", region: str = "", account: str = "") -> None:
        super().__init__(
            service=prefix, resource=resource, region=region, account=account
        )


AcceptInputDeviceTransfer = Action("AcceptInputDeviceTransfer")
BatchDelete = Action("BatchDelete")
BatchStart = Action("BatchStart")
BatchStop = Action("BatchStop")
BatchUpdateSchedule = Action("BatchUpdateSchedule")
CancelInputDeviceTransfer = Action("CancelInputDeviceTransfer")
ClaimDevice = Action("ClaimDevice")
CreateChannel = Action("CreateChannel")
CreateChannelPlacementGroup = Action("CreateChannelPlacementGroup")
CreateCloudWatchAlarmTemplate = Action("CreateCloudWatchAlarmTemplate")
CreateCloudWatchAlarmTemplateGroup = Action("CreateCloudWatchAlarmTemplateGroup")
CreateCluster = Action("CreateCluster")
CreateEventBridgeRuleTemplate = Action("CreateEventBridgeRuleTemplate")
CreateEventBridgeRuleTemplateGroup = Action("CreateEventBridgeRuleTemplateGroup")
CreateInput = Action("CreateInput")
CreateInputSecurityGroup = Action("CreateInputSecurityGroup")
CreateMultiplex = Action("CreateMultiplex")
CreateMultiplexProgram = Action("CreateMultiplexProgram")
CreateNetwork = Action("CreateNetwork")
CreateNode = Action("CreateNode")
CreateNodeRegistrationScript = Action("CreateNodeRegistrationScript")
CreatePartnerInput = Action("CreatePartnerInput")
CreateSignalMap = Action("CreateSignalMap")
CreateTags = Action("CreateTags")
DeleteChannel = Action("DeleteChannel")
DeleteChannelPlacementGroup = Action("DeleteChannelPlacementGroup")
DeleteCloudWatchAlarmTemplate = Action("DeleteCloudWatchAlarmTemplate")
DeleteCloudWatchAlarmTemplateGroup = Action("DeleteCloudWatchAlarmTemplateGroup")
DeleteCluster = Action("DeleteCluster")
DeleteEventBridgeRuleTemplate = Action("DeleteEventBridgeRuleTemplate")
DeleteEventBridgeRuleTemplateGroup = Action("DeleteEventBridgeRuleTemplateGroup")
DeleteInput = Action("DeleteInput")
DeleteInputSecurityGroup = Action("DeleteInputSecurityGroup")
DeleteMultiplex = Action("DeleteMultiplex")
DeleteMultiplexProgram = Action("DeleteMultiplexProgram")
DeleteNetwork = Action("DeleteNetwork")
DeleteNode = Action("DeleteNode")
DeleteReservation = Action("DeleteReservation")
DeleteSchedule = Action("DeleteSchedule")
DeleteSignalMap = Action("DeleteSignalMap")
DeleteTags = Action("DeleteTags")
DescribeAccountConfiguration = Action("DescribeAccountConfiguration")
DescribeChannel = Action("DescribeChannel")
DescribeChannelPlacementGroup = Action("DescribeChannelPlacementGroup")
DescribeCluster = Action("DescribeCluster")
DescribeInput = Action("DescribeInput")
DescribeInputDevice = Action("DescribeInputDevice")
DescribeInputDeviceThumbnail = Action("DescribeInputDeviceThumbnail")
DescribeInputSecurityGroup = Action("DescribeInputSecurityGroup")
DescribeMultiplex = Action("DescribeMultiplex")
DescribeMultiplexProgram = Action("DescribeMultiplexProgram")
DescribeNetwork = Action("DescribeNetwork")
DescribeNode = Action("DescribeNode")
DescribeOffering = Action("DescribeOffering")
DescribeReservation = Action("DescribeReservation")
DescribeSchedule = Action("DescribeSchedule")
DescribeThumbnails = Action("DescribeThumbnails")
GetCloudWatchAlarmTemplate = Action("GetCloudWatchAlarmTemplate")
GetCloudWatchAlarmTemplateGroup = Action("GetCloudWatchAlarmTemplateGroup")
GetEventBridgeRuleTemplate = Action("GetEventBridgeRuleTemplate")
GetEventBridgeRuleTemplateGroup = Action("GetEventBridgeRuleTemplateGroup")
GetSignalMap = Action("GetSignalMap")
ListChannelPlacementGroups = Action("ListChannelPlacementGroups")
ListChannels = Action("ListChannels")
ListCloudWatchAlarmTemplateGroups = Action("ListCloudWatchAlarmTemplateGroups")
ListCloudWatchAlarmTemplates = Action("ListCloudWatchAlarmTemplates")
ListClusters = Action("ListClusters")
ListEventBridgeRuleTemplateGroups = Action("ListEventBridgeRuleTemplateGroups")
ListEventBridgeRuleTemplates = Action("ListEventBridgeRuleTemplates")
ListInputDeviceTransfers = Action("ListInputDeviceTransfers")
ListInputDevices = Action("ListInputDevices")
ListInputSecurityGroups = Action("ListInputSecurityGroups")
ListInputs = Action("ListInputs")
ListMultiplexPrograms = Action("ListMultiplexPrograms")
ListMultiplexes = Action("ListMultiplexes")
ListNetworks = Action("ListNetworks")
ListNodes = Action("ListNodes")
ListOfferings = Action("ListOfferings")
ListReservations = Action("ListReservations")
ListSignalMaps = Action("ListSignalMaps")
ListTagsForResource = Action("ListTagsForResource")
ListVersions = Action("ListVersions")
PollAnywhere = Action("PollAnywhere")
PurchaseOffering = Action("PurchaseOffering")
RebootInputDevice = Action("RebootInputDevice")
RejectInputDeviceTransfer = Action("RejectInputDeviceTransfer")
RestartChannelPipelines = Action("RestartChannelPipelines")
StartChannel = Action("StartChannel")
StartDeleteMonitorDeployment = Action("StartDeleteMonitorDeployment")
StartInputDevice = Action("StartInputDevice")
StartInputDeviceMaintenanceWindow = Action("StartInputDeviceMaintenanceWindow")
StartMonitorDeployment = Action("StartMonitorDeployment")
StartMultiplex = Action("StartMultiplex")
StartUpdateSignalMap = Action("StartUpdateSignalMap")
StopChannel = Action("StopChannel")
StopInputDevice = Action("StopInputDevice")
StopMultiplex = Action("StopMultiplex")
SubmitAnywhereStateChange = Action("SubmitAnywhereStateChange")
TransferInputDevice = Action("TransferInputDevice")
UpdateAccountConfiguration = Action("UpdateAccountConfiguration")
UpdateChannel = Action("UpdateChannel")
UpdateChannelClass = Action("UpdateChannelClass")
UpdateChannelPlacementGroup = Action("UpdateChannelPlacementGroup")
UpdateCloudWatchAlarmTemplate = Action("UpdateCloudWatchAlarmTemplate")
UpdateCloudWatchAlarmTemplateGroup = Action("UpdateCloudWatchAlarmTemplateGroup")
UpdateCluster = Action("UpdateCluster")
UpdateEventBridgeRuleTemplate = Action("UpdateEventBridgeRuleTemplate")
UpdateEventBridgeRuleTemplateGroup = Action("UpdateEventBridgeRuleTemplateGroup")
UpdateInput = Action("UpdateInput")
UpdateInputDevice = Action("UpdateInputDevice")
UpdateInputSecurityGroup = Action("UpdateInputSecurityGroup")
UpdateMultiplex = Action("UpdateMultiplex")
UpdateMultiplexProgram = Action("UpdateMultiplexProgram")
UpdateNetwork = Action("UpdateNetwork")
UpdateNode = Action("UpdateNode")
UpdateNodeState = Action("UpdateNodeState")
UpdateReservation = Action("UpdateReservation")
