# Copyright (c) 2012-2021, Mark Peek <mark@peek.org>
# All rights reserved.
#
# See LICENSE file for full license.

from typing import Optional

from .aws import Action as BaseAction
from .aws import BaseARN

service_name = "Amazon QuickSight"
prefix = "quicksight"


class Action(BaseAction):
    def __init__(self, action: Optional[str] = None) -> None:
        super().__init__(prefix, action)


class ARN(BaseARN):
    def __init__(self, resource: str = "", region: str = "", account: str = "") -> None:
        super().__init__(
            service=prefix, resource=resource, region=region, account=account
        )


AccountConfigurations = Action("AccountConfigurations")
BatchCreateTopicReviewedAnswer = Action("BatchCreateTopicReviewedAnswer")
BatchDeleteTopicReviewedAnswer = Action("BatchDeleteTopicReviewedAnswer")
CancelIngestion = Action("CancelIngestion")
CreateAccountCustomization = Action("CreateAccountCustomization")
CreateAccountSubscription = Action("CreateAccountSubscription")
CreateAdmin = Action("CreateAdmin")
CreateAnalysis = Action("CreateAnalysis")
CreateBrand = Action("CreateBrand")
CreateCustomPermissions = Action("CreateCustomPermissions")
CreateDashboard = Action("CreateDashboard")
CreateDataSet = Action("CreateDataSet")
CreateDataSource = Action("CreateDataSource")
CreateEmailCustomizationTemplate = Action("CreateEmailCustomizationTemplate")
CreateFolder = Action("CreateFolder")
CreateFolderMembership = Action("CreateFolderMembership")
CreateGroup = Action("CreateGroup")
CreateGroupMembership = Action("CreateGroupMembership")
CreateIAMPolicyAssignment = Action("CreateIAMPolicyAssignment")
CreateIngestion = Action("CreateIngestion")
CreateNamespace = Action("CreateNamespace")
CreateReader = Action("CreateReader")
CreateRefreshSchedule = Action("CreateRefreshSchedule")
CreateRoleMembership = Action("CreateRoleMembership")
CreateTemplate = Action("CreateTemplate")
CreateTemplateAlias = Action("CreateTemplateAlias")
CreateTheme = Action("CreateTheme")
CreateThemeAlias = Action("CreateThemeAlias")
CreateTopic = Action("CreateTopic")
CreateTopicRefreshSchedule = Action("CreateTopicRefreshSchedule")
CreateUser = Action("CreateUser")
CreateVPCConnection = Action("CreateVPCConnection")
DeleteAccountCustomization = Action("DeleteAccountCustomization")
DeleteAccountSubscription = Action("DeleteAccountSubscription")
DeleteAnalysis = Action("DeleteAnalysis")
DeleteBrand = Action("DeleteBrand")
DeleteBrandAssignment = Action("DeleteBrandAssignment")
DeleteCustomPermissions = Action("DeleteCustomPermissions")
DeleteDashboard = Action("DeleteDashboard")
DeleteDataSet = Action("DeleteDataSet")
DeleteDataSetRefreshProperties = Action("DeleteDataSetRefreshProperties")
DeleteDataSource = Action("DeleteDataSource")
DeleteDefaultQBusinessApplication = Action("DeleteDefaultQBusinessApplication")
DeleteEmailCustomizationTemplate = Action("DeleteEmailCustomizationTemplate")
DeleteFolder = Action("DeleteFolder")
DeleteFolderMembership = Action("DeleteFolderMembership")
DeleteGroup = Action("DeleteGroup")
DeleteGroupMembership = Action("DeleteGroupMembership")
DeleteIAMPolicyAssignment = Action("DeleteIAMPolicyAssignment")
DeleteIdentityPropagationConfig = Action("DeleteIdentityPropagationConfig")
DeleteNamespace = Action("DeleteNamespace")
DeleteRefreshSchedule = Action("DeleteRefreshSchedule")
DeleteRoleCustomPermission = Action("DeleteRoleCustomPermission")
DeleteRoleMembership = Action("DeleteRoleMembership")
DeleteTemplate = Action("DeleteTemplate")
DeleteTemplateAlias = Action("DeleteTemplateAlias")
DeleteTheme = Action("DeleteTheme")
DeleteThemeAlias = Action("DeleteThemeAlias")
DeleteTopic = Action("DeleteTopic")
DeleteTopicRefreshSchedule = Action("DeleteTopicRefreshSchedule")
DeleteUser = Action("DeleteUser")
DeleteUserByPrincipalId = Action("DeleteUserByPrincipalId")
DeleteUserCustomPermission = Action("DeleteUserCustomPermission")
DeleteVPCConnection = Action("DeleteVPCConnection")
DescribeAccountCustomization = Action("DescribeAccountCustomization")
DescribeAccountSettings = Action("DescribeAccountSettings")
DescribeAccountSubscription = Action("DescribeAccountSubscription")
DescribeAnalysis = Action("DescribeAnalysis")
DescribeAnalysisPermissions = Action("DescribeAnalysisPermissions")
DescribeAssetBundleExportJob = Action("DescribeAssetBundleExportJob")
DescribeAssetBundleImportJob = Action("DescribeAssetBundleImportJob")
DescribeBrand = Action("DescribeBrand")
DescribeBrandAssignment = Action("DescribeBrandAssignment")
DescribeBrandPublishedVersion = Action("DescribeBrandPublishedVersion")
DescribeCustomPermissions = Action("DescribeCustomPermissions")
DescribeDashboard = Action("DescribeDashboard")
DescribeDashboardPermissions = Action("DescribeDashboardPermissions")
DescribeDashboardSnapshotJob = Action("DescribeDashboardSnapshotJob")
DescribeDashboardSnapshotJobResult = Action("DescribeDashboardSnapshotJobResult")
DescribeDashboardsQAConfiguration = Action("DescribeDashboardsQAConfiguration")
DescribeDataSet = Action("DescribeDataSet")
DescribeDataSetPermissions = Action("DescribeDataSetPermissions")
DescribeDataSetRefreshProperties = Action("DescribeDataSetRefreshProperties")
DescribeDataSource = Action("DescribeDataSource")
DescribeDataSourcePermissions = Action("DescribeDataSourcePermissions")
DescribeDefaultQBusinessApplication = Action("DescribeDefaultQBusinessApplication")
DescribeEmailCustomizationTemplate = Action("DescribeEmailCustomizationTemplate")
DescribeFolder = Action("DescribeFolder")
DescribeFolderPermissions = Action("DescribeFolderPermissions")
DescribeFolderResolvedPermissions = Action("DescribeFolderResolvedPermissions")
DescribeGroup = Action("DescribeGroup")
DescribeGroupMembership = Action("DescribeGroupMembership")
DescribeIAMPolicyAssignment = Action("DescribeIAMPolicyAssignment")
DescribeIngestion = Action("DescribeIngestion")
DescribeIpRestriction = Action("DescribeIpRestriction")
DescribeKeyRegistration = Action("DescribeKeyRegistration")
DescribeNamespace = Action("DescribeNamespace")
DescribeQPersonalizationConfiguration = Action("DescribeQPersonalizationConfiguration")
DescribeQuickSightQSearchConfiguration = Action(
    "DescribeQuickSightQSearchConfiguration"
)
DescribeRefreshSchedule = Action("DescribeRefreshSchedule")
DescribeRoleCustomPermission = Action("DescribeRoleCustomPermission")
DescribeTemplate = Action("DescribeTemplate")
DescribeTemplateAlias = Action("DescribeTemplateAlias")
DescribeTemplatePermissions = Action("DescribeTemplatePermissions")
DescribeTheme = Action("DescribeTheme")
DescribeThemeAlias = Action("DescribeThemeAlias")
DescribeThemePermissions = Action("DescribeThemePermissions")
DescribeTopic = Action("DescribeTopic")
DescribeTopicPermissions = Action("DescribeTopicPermissions")
DescribeTopicRefresh = Action("DescribeTopicRefresh")
DescribeTopicRefreshSchedule = Action("DescribeTopicRefreshSchedule")
DescribeUser = Action("DescribeUser")
DescribeVPCConnection = Action("DescribeVPCConnection")
GenerateEmbedUrlForAnonymousUser = Action("GenerateEmbedUrlForAnonymousUser")
GenerateEmbedUrlForRegisteredUser = Action("GenerateEmbedUrlForRegisteredUser")
GenerateEmbedUrlForRegisteredUserWithIdentity = Action(
    "GenerateEmbedUrlForRegisteredUserWithIdentity"
)
GetAnonymousUserEmbedUrl = Action("GetAnonymousUserEmbedUrl")
GetAuthCode = Action("GetAuthCode")
GetDashboardEmbedUrl = Action("GetDashboardEmbedUrl")
GetGroupMapping = Action("GetGroupMapping")
GetSessionEmbedUrl = Action("GetSessionEmbedUrl")
ListAnalyses = Action("ListAnalyses")
ListAssetBundleExportJobs = Action("ListAssetBundleExportJobs")
ListAssetBundleImportJobs = Action("ListAssetBundleImportJobs")
ListBrands = Action("ListBrands")
ListCustomPermissions = Action("ListCustomPermissions")
ListCustomerManagedKeys = Action("ListCustomerManagedKeys")
ListDashboardVersions = Action("ListDashboardVersions")
ListDashboards = Action("ListDashboards")
ListDataSets = Action("ListDataSets")
ListDataSources = Action("ListDataSources")
ListFolderMembers = Action("ListFolderMembers")
ListFolders = Action("ListFolders")
ListFoldersForResource = Action("ListFoldersForResource")
ListGroupMemberships = Action("ListGroupMemberships")
ListGroups = Action("ListGroups")
ListIAMPolicyAssignments = Action("ListIAMPolicyAssignments")
ListIAMPolicyAssignmentsForUser = Action("ListIAMPolicyAssignmentsForUser")
ListIdentityPropagationConfigs = Action("ListIdentityPropagationConfigs")
ListIngestions = Action("ListIngestions")
ListKMSKeysForUser = Action("ListKMSKeysForUser")
ListNamespaces = Action("ListNamespaces")
ListRefreshSchedules = Action("ListRefreshSchedules")
ListRoleMemberships = Action("ListRoleMemberships")
ListTagsForResource = Action("ListTagsForResource")
ListTemplateAliases = Action("ListTemplateAliases")
ListTemplateVersions = Action("ListTemplateVersions")
ListTemplates = Action("ListTemplates")
ListThemeAliases = Action("ListThemeAliases")
ListThemeVersions = Action("ListThemeVersions")
ListThemes = Action("ListThemes")
ListTopicRefreshSchedules = Action("ListTopicRefreshSchedules")
ListTopicReviewedAnswers = Action("ListTopicReviewedAnswers")
ListTopics = Action("ListTopics")
ListUserGroups = Action("ListUserGroups")
ListUsers = Action("ListUsers")
ListVPCConnections = Action("ListVPCConnections")
PassDataSet = Action("PassDataSet")
PassDataSource = Action("PassDataSource")
PredictQAResults = Action("PredictQAResults")
PutDataSetRefreshProperties = Action("PutDataSetRefreshProperties")
RegisterCustomerManagedKey = Action("RegisterCustomerManagedKey")
RegisterUser = Action("RegisterUser")
RemoveCustomerManagedKey = Action("RemoveCustomerManagedKey")
RestoreAnalysis = Action("RestoreAnalysis")
ScopeDownPolicy = Action("ScopeDownPolicy")
SearchAnalyses = Action("SearchAnalyses")
SearchDashboards = Action("SearchDashboards")
SearchDataSets = Action("SearchDataSets")
SearchDataSources = Action("SearchDataSources")
SearchDirectoryGroups = Action("SearchDirectoryGroups")
SearchFolders = Action("SearchFolders")
SearchGroups = Action("SearchGroups")
SearchTopics = Action("SearchTopics")
SearchUsers = Action("SearchUsers")
SetGroupMapping = Action("SetGroupMapping")
StartAssetBundleExportJob = Action("StartAssetBundleExportJob")
StartAssetBundleImportJob = Action("StartAssetBundleImportJob")
StartDashboardSnapshotJob = Action("StartDashboardSnapshotJob")
StartDashboardSnapshotJobSchedule = Action("StartDashboardSnapshotJobSchedule")
Subscribe = Action("Subscribe")
TagResource = Action("TagResource")
Unsubscribe = Action("Unsubscribe")
UntagResource = Action("UntagResource")
UpdateAccountCustomization = Action("UpdateAccountCustomization")
UpdateAccountSettings = Action("UpdateAccountSettings")
UpdateAnalysis = Action("UpdateAnalysis")
UpdateAnalysisPermissions = Action("UpdateAnalysisPermissions")
UpdateApplicationWithTokenExchangeGrant = Action(
    "UpdateApplicationWithTokenExchangeGrant"
)
UpdateBrand = Action("UpdateBrand")
UpdateBrandAssignment = Action("UpdateBrandAssignment")
UpdateBrandPublishedVersion = Action("UpdateBrandPublishedVersion")
UpdateCustomPermissions = Action("UpdateCustomPermissions")
UpdateDashboard = Action("UpdateDashboard")
UpdateDashboardLinks = Action("UpdateDashboardLinks")
UpdateDashboardPermissions = Action("UpdateDashboardPermissions")
UpdateDashboardPublishedVersion = Action("UpdateDashboardPublishedVersion")
UpdateDashboardsQAConfiguration = Action("UpdateDashboardsQAConfiguration")
UpdateDataSet = Action("UpdateDataSet")
UpdateDataSetPermissions = Action("UpdateDataSetPermissions")
UpdateDataSource = Action("UpdateDataSource")
UpdateDataSourcePermissions = Action("UpdateDataSourcePermissions")
UpdateDefaultQBusinessApplication = Action("UpdateDefaultQBusinessApplication")
UpdateEmailCustomizationTemplate = Action("UpdateEmailCustomizationTemplate")
UpdateFolder = Action("UpdateFolder")
UpdateFolderPermissions = Action("UpdateFolderPermissions")
UpdateGroup = Action("UpdateGroup")
UpdateIAMPolicyAssignment = Action("UpdateIAMPolicyAssignment")
UpdateIdentityPropagationConfig = Action("UpdateIdentityPropagationConfig")
UpdateIpRestriction = Action("UpdateIpRestriction")
UpdateKeyRegistration = Action("UpdateKeyRegistration")
UpdatePublicSharingSettings = Action("UpdatePublicSharingSettings")
UpdateQPersonalizationConfiguration = Action("UpdateQPersonalizationConfiguration")
UpdateQuickSightQSearchConfiguration = Action("UpdateQuickSightQSearchConfiguration")
UpdateRefreshSchedule = Action("UpdateRefreshSchedule")
UpdateResourcePermissions = Action("UpdateResourcePermissions")
UpdateRoleCustomPermission = Action("UpdateRoleCustomPermission")
UpdateSPICECapacityConfiguration = Action("UpdateSPICECapacityConfiguration")
UpdateTemplate = Action("UpdateTemplate")
UpdateTemplateAlias = Action("UpdateTemplateAlias")
UpdateTemplatePermissions = Action("UpdateTemplatePermissions")
UpdateTheme = Action("UpdateTheme")
UpdateThemeAlias = Action("UpdateThemeAlias")
UpdateThemePermissions = Action("UpdateThemePermissions")
UpdateTopic = Action("UpdateTopic")
UpdateTopicPermissions = Action("UpdateTopicPermissions")
UpdateTopicRefreshSchedule = Action("UpdateTopicRefreshSchedule")
UpdateUser = Action("UpdateUser")
UpdateUserCustomPermission = Action("UpdateUserCustomPermission")
UpdateVPCConnection = Action("UpdateVPCConnection")
